#include <cstdio>
#include <vector>
#include <omp.h>

typedef size_t intt;
const intt count = 1 << 30;

intt sum_reduction(std::vector<intt> &data) {
    intt sum = 0;
    #pragma omp parallel for reduction(+:sum)
    for (intt i=0; i<count; i++) {
        sum += data[i];
    }
    return sum;
}

intt sum_custom(std::vector<intt> &data) {
    intt total_sum = 0;
    #pragma omp parallel
    {
        intt sum = 0;
        int tid = omp_get_thread_num(), ttotal = omp_get_num_threads();
        intt start = count * tid / ttotal;
        intt end = count * (tid + 1) / ttotal;
        #pragma omp threadlocal(sum)
        for (intt i=start; i<end; i++) {
            sum += data[i];
        }
        #pragma omp critical
        total_sum += sum;
    }
    return total_sum;
}

int main(int argc, char *argv[])
{
    std::vector<intt> data;
    for (intt i=0; i<count; i++) {
        data.push_back(i + 1);
    }

    double start_time = omp_get_wtime();
    intt sum;
    if (0) {
        sum = sum_reduction(data);
    } else {
        sum = sum_custom(data);
    }
    double end_time = omp_get_wtime();
    printf("Součet: %lu za %f s\n", sum, end_time - start_time);
    printf("Má být: %lu\n", count * (count + 1) / 2);
}